'From Smalltalk/X, Version:5.2.8 on 13-01-2008 at 15:44:38'                     !

"{ Package: 'SpreadSheet:andrep1' }"

AbstractExporter subclass:#CSVExporter
	instanceVariableNames:'file dateFormat dateLanguage timeFormat'
	classVariableNames:''
	poolDictionaries:''
	category:'obp-SpreadSheet'
!

!CSVExporter methodsFor:'exporter-settings'!

setDateFormat: format language: languageOrNil
    dateFormat:= format.
    dateLanguage:= languageOrNil.
    ^ self
!

setFile: fileName
    "Exports undefined value, because this object cannot be exported"
           file:= FileStream new.
           file open: fileName withMode: 'w'.
    ^ self
!

setTimeFormat: format
    timeFormat:= format.

    ^ self
! !

!CSVExporter methodsFor:'spreadsheet-exporting'!

export:spreadSheet
    "Exports SpredSheet"
     spreadSheet rowsDo:
     [ :r |
       | first |
       first:=true.
       r do:
       [:e |
        first ifTrue: [ first:=false. ] ifFalse: [file print: ','. ].
        e exportUsing: self.
       ].
       file cr.
     ].
     file close.
    ^ self 
!

exportCellExpression:anObject 
    (anObject value) exportUsing: self.
    ^ self
!

exportDate:anObject

    "Exports Date"
     dateFormat isNil ifTrue: [ dateFormat:='%d-%m-%m'].

     "anObject printOn: exportie format: dateFormat language: dateLanguage."
     self exportString: (anObject printStringFormat: dateFormat language: dateLanguage).
    ^ self
!

exportEmpty:anObject
    "Exports String."
    file print: ''.    
    ^ self 
!

exportNumber:anObject 
    "Exports Number. Maybe there must be special method for every Number subclass we expect to be used."
     file print: anObject.
    ^ self
!

exportString:anObject 
    "Exports String."
     file print: '"'.
     anObject do:
     [ :c |
       (c = $") ifTrue: [file print: '"'].
       file print: c.
     ].
     file print: '"'.
    ^ self
!

exportTime:anObject 
    "Exports time"
    timeFormat isNil ifTrue: [ timeFormat:='%h:%m:%s'].

    self exportString: (anObject printStringFormat: timeFormat).
    ^ self 
!

exportUndefined:anObject 
    "Exports undefined value, because this object cannot be exported"
     file print: ''.
    ^ self
! !

